<?php

namespace App\Models;

use App\Enums\PriceType;
use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Attributes\Scope;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

#[Appends(['formatted_price', 'type_label'])]
#[Guarded(['id'])]
class ProductPrice extends Model
{
    use HasFactory;

    protected function casts(): array
    {
        return [
            'type' => PriceType::class,
            'price' => 'integer',
        ];
    }

    protected function formattedPrice(): Attribute
    {
        return Attribute::make(
            get: fn () => 'Rp '.number_format($this->price, 0, ',', '.'),
        );
    }

    #[Scope]
    protected function retail(Builder $query): void
    {
        $query->where('type', PriceType::RETAIL);
    }

    #[Scope]
    protected function wholesale(Builder $query): void
    {
        $query->where('type', PriceType::WHOLESALE);
    }

    public function variant(): BelongsTo
    {
        return $this->belongsTo(ProductVariant::class, 'variant_id');
    }

    protected function typeLabel(): Attribute
    {
        return Attribute::make(
            get: fn () => $this->type->label(),
        );
    }
}
